-- Author      : admin
-- Create Date : 10/13/2019 2:29:28 PM

do
    local a = newArray();
    local b = a.map();

    assert(#b == 0, 'expect #b to be 0');
end

do
    local a = newArray(1, 2, 3);
    local b = a.map();

    assert(#b == 0, 'expect #b to be 3');
end

do
    local a = newArray('1');
    
    local b = a.map(function(v, i, arr)
        assert(type(v) == 'string');
        assert(type(i) == 'number');
        assert(type(arr) == 'table');
        assert(arr == a);

        return i;
    end);

    assert(#b == 1, 'expect #b to be 1');
    assert(b[1] == 1, 'expect #b to be 1');
end
